/**
	by LINK/2012 (http://www.link2012world.blogspot.com/)
*/
#pragma once

// NAKED macro - I hate to write declspec!
#define NAKED	__declspec(naked)

//
//	Hooker functions macros
//
#define DEFINE_HOOKER(Hook_Name)		NAKED void Hook_Name (void)
#define DECLARE_HOOKER(Hook_Name)		void Hook_Name (void);

//
//	ASM EPILOG and ASM PROLOG macros
//
#define ASM_PROLOG() _asm					\
	{										\
		_asm push	ebp						\
		_asm mov	ebp, esp				\
		_asm sub	esp, __LOCAL_SIZE		\
	}

#define ASM_EPILOG() _asm					\
	{										\
		_asm mov	esp, ebp				\
		_asm pop	ebp						\
	}
