/**
	The Birds Update
	ASI Plugin	(Programming)	- by LINK/2012		(http://www.link2012world.blogspot.com/)
	New Birds	(Textures)		- by Junior_Djjr	(http://juniordjjr.blogspot.com.br/)
*/
#define _CRT_SECURE_NO_WARNINGS
#include <Windows.h>
#include "Injector.h"
#include "CBirds.h"
#include "Injector.h"
#include "Addresses.h"
#include "Commands.h"

/////////////////////////////////////////////////////////////
// Patch function										   //
/////////////////////////////////////////////////////////////
void Patch()
{
	// Init address pointers
	InitAddresses();
	CBirds_InitMethods();

	// Replace bird funcs
	MakeJMP(0x711EE8, &CBirds::Init);
	MakeJMP(0x712321, &CBirds::UnInit);
	MakeJMP(0x712E40, &CBirds::CheckIfHitByFire);
	MakeJMP(0x712330, &CBirds::Process);
	MakeJMP(0x711EF0, &CBirds::Add);
	MakeJMP(0x712810, &CBirds::Render);

	// Replace command 0876
	MakeJMP(0x47195E, &Command_0876);
}
///////////////////////////////////////////////////////////////


BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		{
			GameVersion gv(SA);
			if(gv.Get() != gv.SA_10US)
			{
				char Buffer[128];
				sprintf(Buffer, "An incompatible exe version has been detected! (%s)\n"
								"Do you want to continue anyway? (Not recommended)", gv.GetString());
				if(MessageBoxA(0, Buffer, "The Birds Update", MB_YESNO|MB_ICONERROR|MB_DEFBUTTON2) == IDNO)
					return false;
			}
			
			Patch();
			break;
		}
		
		case DLL_PROCESS_DETACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
			break;
	
	}
	
	return true;
}



